%--------------------------------------------------------------------------
%The HMM Level 
%-------------
%Nod hmm
T = 6; % length (no. of symbols) of a training example
nex = 38; %no. of examples 
load nods.txt
nods = nods(randperm(size(nods,1)),:);
noddata	= nods(1:nex,1:T);

[LLnod, disp_prior{1} , disp_transmat{1}, disp_obsmat{1}] = mk_HD_hmm(noddata); 

%shake hmm
T = 6; % length (no. of symbols) of a training example
nex = 30; %no. of examples 
load shakes.txt
shakes = shakes(randperm(size(shakes,1)),:);
shakedata	= shakes(1:nex,1:T);
[LLshake, disp_prior{2} , disp_transmat{2}, disp_obsmat{2}] = mk_HD_hmm(shakedata); 

T = 6; % length (no. of symbols) of a training example
nex = 65; %no. of examples 
load tilts.txt
tilts = tilts(randperm(size(tilts,1)),:);
tiltdata	= tilts(1:nex,1:T);
[LLtilt, disp_prior{3} , disp_transmat{3}, disp_obsmat{3}] = mk_HD1_hmm(tiltdata) ;

T = 6; % length (no. of symbols) of a training example
nex = 70; %no. of examples 
load turns.txt
turns = turns(randperm(size(turns,1)),:);
turndata	= turns(1:nex,1:T);
[LLturn, disp_prior{4} , disp_transmat{4}, disp_obsmat{4}] = mk_HD1_hmm(turndata); 

%smile HMM
T = 6; % length (no. of symbols) of a training example
nex = 20; %no. of examples 
load smiles.txt
smiles = smiles(randperm(size(smiles,1)),:);
lcpdata	= smiles(1:nex,1:T);
[LLlcp, disp_prior{5} , disp_transmat{5}, disp_obsmat{5}] = mk_mouth_hmm(lcpdata);

%Puckerer HMM 
T = 6; % length (no. of symbols) of a training example
nex = 49; %no. of examples 
load puckerers.txt
puckerers = puckerers(randperm(size(puckerers,1)),:);
puckererdata	= puckerers(1:nex,1:T);
[LLpuckerer, disp_prior{6} , disp_transmat{6}, disp_obsmat{6}] = mk_mouth_hmm(puckererdata);

%Eyebrow raise HMM 
T = 6; % length (no. of symbols) of a training example
nex = 49; %no. of examples 
load raises.txt
raises = raises(randperm(size(raises,1)),:);
raisedata	= raises(1:nex,1:T);
[LLraise, disp_prior{7} , disp_transmat{7}, disp_obsmat{7}] = mk_brow_hmm(raisedata);

%mouth open HMM 
T = 6; % length (no. of symbols) of a training example
nex = 44; %no. of examples 
load mouthopen.txt
mouthopen = mouthopen(randperm(size(mouthopen,1)),:);
mouthopendata	= mouthopen(1:nex,1:T);
[LLturn, disp_prior{8} , disp_transmat{8}, disp_obsmat{8}] = mk_mouth_hmm(mouthopendata); 

%teeth HMM
T = 6; % length (no. of symbols) of a training example
nex = 44; %no. of examples 
load teeth.txt
teeth = teeth(randperm(size(teeth,1)),:);
teethdata	= teeth(1:nex,1:T);
[LLturn, disp_prior{9} , disp_transmat{9}, disp_obsmat{9}] = mk_mouth_hmm(teethdata); 

save('hmms_params', 'disp_prior', 'disp_transmat', 'disp_obsmat');